/* Example for data chacking*/
#include "CifFile.h"
#include "DicFile.h"
#include "DdlFile.h"
#include "CifParserBase.h"
#include "DDLParserBase.h"
#include "DICParserBase.h"
#include <iostream>
#include <time.h>


#define FALSE 0
#define NS 10
int main(int argc, char *argv[]) {
  string diags;
  DdlFile * ddl = NULL;
  DicFile * dic = NULL;
  CifFile * fobjR = NULL;
  time_t start,end;
  FILE * fpN;
  string cifFile;

  CifParser* cifParserR = NULL;
  DICParser* dicParserR = NULL;
  DDLParser* ddlParserR = NULL;

  if (argc < 2)
  {
    cerr << argv[0] << ":  usage = cifFile <dicFile> <ddlFile>" << endl;
    exit(1);
  }

  cifFile = argv[1];          

  string dicFile;

  if (argc > 2)
  {
    dicFile = argv[2];
  }

  string ddlFile = "./ddl-mm";

  if (argc > 3)
  {
    ddlFile = argv[3];
  }

  time(&start);
  ddl = new DdlFile(true);

  ddlParserR = new DDLParser(ddl, ddl->GetVerbose());

  ddlParserR->Parse(ddlFile, diags);

  delete(ddlParserR);

  cout<<"diags = ";
  if (!(diags.empty()))
  {
    cout<<diags;
  }

  ddl->DataChecking(*ddl);

  cout<<endl;
  time(&end);

  cout<<"second(s)"<<difftime(end,start)<<endl;

  time(&start);
  if (dicFile.empty())
  {
    if((fpN=fopen("./dictionary.sdb","r")) == NULL)
    {
      cout<<"First time"<<endl;
      dic = new DicFile(CREATE_MODE, "./dictionary.sdb");
  
      dicParserR = new DICParser(dic, ddl, dic->GetVerbose());

      dicParserR->Parse("./dictionary.dic", diags);

      delete(dicParserR);

    }
    else
    {
      fclose(fpN);
      dic = new DicFile(READ_MODE, "./dictionary.sdb");
    }
  }
  else
  {
      dic = new DicFile();
  
      dicParserR = new DICParser(dic, ddl, dic->GetVerbose());

      dicParserR->Parse(dicFile, diags);

      delete(dicParserR);
  }
  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;
  cout<<"diags = ";
  if (!(diags.empty()))
  {
    cout<<diags;
  }
  cout<<endl;

  dic->Compress(ddl);

  dic->DataChecking(*ddl);

  time(&start);
  fobjR = new CifFile(true);
  cout<<cifFile<<endl;

  cifParserR = new CifParser(fobjR, fobjR->GetVerbose());

  cifParserR->Parse(cifFile, diags);

  delete(cifParserR);

  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;
  cout<<"============================="<<endl;
  time(&start);
  fobjR->DataChecking(*dic);

  time(&end);
  cout<<"second(s)"<<difftime(end,start)<<endl;
  ddl->Close();
  if (ddl) delete ddl;
  dic->Close();
  if (dic) delete dic;
  fobjR->Close();
  if (fobjR) delete fobjR;
exit(0);
}
