
#include "DicFile.h"
#include "DdlFile.h"
#include "DICParserBase.h"
#include "DDLParserBase.h"

#include <iostream>

#define FALSE 0
int main() {
  string diags;
  DicFile * fobjR = NULL;
  DdlFile * ddl = NULL;

  DICParser* dicParserR = NULL;
  DDLParser* ddlParserR = NULL;


  ddl = new DdlFile(true);

  ddlParserR = new DDLParser(ddl, ddl->GetVerbose());

  ddlParserR->Parse("./ddl-mm", diags);

  delete(ddlParserR);

  cout<<"diags = ";
  if (!(diags.empty()))
  {
    cout<<diags;
  }
  cout<<endl;


  fobjR = new DicFile(CREATE_MODE, "./test5.sdb");

  dicParserR = new DICParser(fobjR, ddl, fobjR->GetVerbose());

  dicParserR->Parse("./dictionary.dic", diags);
  
  delete(dicParserR);

  cout<<"diags = ";
  if (!(diags.empty()))
  {
    cout<<diags;
  }
  cout<<endl;

  fobjR->Compress(ddl);
  fobjR->Write("./view2.ocif");
  fobjR->WriteFormatted("./view2.dic",ddl);

  fobjR->Close();
  if (fobjR) delete fobjR;
  exit(0);
}

