/* Example for dictionary chacking*/
#include "CifFile.h"
#include "DicFile.h"
#include "DdlFile.h"
#include "DICParserBase.h"
#include "DDLParserBase.h"
#include <iostream>


int main(int argc, char *argv[]) {
  string diags;
  DdlFile * ddl = NULL;
  DicFile * dic = NULL;

  DICParser* dicParserR = NULL;
  DDLParser* ddlParserR = NULL;


  int i;
  string ddlFile;
  string dicFile;


  if (argc < 4) {
    cerr << argv[0] << ":  usage = -ddl <ddlfile> -dic <dictionaryfile> " << endl;
    exit(1);
  }

  for (i=1; i < argc; i++) {
    if ( argv[i][0] == '-' ) {
      if (strcmp(argv[i],"-ddl") == 0 ) {
	i++;
	ddlFile = argv[i];          
      }	else if (strcmp(argv[i],"-dic") == 0 ) {
	i++;
	dicFile = argv[i];          
      } else {
	cerr << argv[0] << ":  usage = -ddl <ddlfile> -dic <dictionaryfile> " << endl;
	exit(1);
      }
    } else {
      cerr << argv[0] << ":  usage = -ddl <ddlfile> -dic <dictionaryfile> " << endl;
      exit(1);
    }
  }

  ddl = new DdlFile(true);

  ddlParserR = new DDLParser(ddl, ddl->GetVerbose());

  ddlParserR->Parse(ddlFile, diags);

  delete(ddlParserR);

  cout<<"diags from DDL reading= "<<diags<<endl;

  dic = new DicFile(CREATE_MODE, "dictionary.sdb");

  dicParserR = new DICParser(dic, ddl, dic->GetVerbose());

  dicParserR->Parse(dicFile, diags);

  delete(dicParserR);

  cout<<"diags from Dictionary reding= "<<diags<<endl;

//  dic->Compress(ddl);

  ddl->Close();
  if (ddl) delete ddl;
  dic->Close();
  if (dic) delete dic;
exit(0);
}
